MODULE tlist7;
        (* C: Broser 24.4.89 *)
        (* Testumgebung zum Listenmodul Liste7 *)
FROM SYSTEM IMPORT ADR, ADDRESS;
FROM InOut
   IMPORT  WriteString, WriteLn, ReadString, Read;
FROM formatausgabe IMPORT WriteRText, WriteLText;
FROM Storage
   IMPORT ALLOCATE;
FROM Strings
   IMPORT CompareStr;
FROM Liste7
   IMPORT tList (* Typ *),
          ErzeugeListe, EinfuegenKopf,EinfuegenSchwanz,
          SortiertEinfuegen, ZumnaechstenElement,ZumvorigenElement,
          ZumVergleichselement,ZumKopf,ZumSchwanz,LoescheElement,AusgabeElement,
          EntferneAusListe,  (* Prozeduren *)
          erstesElement, letztesElement, leereListe; (* Funktionen *)

  TYPE
        STRING = ARRAY[1..25] OF CHAR;
        zeiger = POINTER TO datensatz;
        datensatz = RECORD
                      name   :  STRING;
                      zeit   :  STRING;
                    END;

  VAR liste : tList;

  PROCEDURE erzeugedatensatz(VAR z : zeiger);
    BEGIN
      NEW(z);
      WriteString('Name : ');
      ReadString(z^.name);
      WriteLn;
      WriteString('Zeit : ');
      ReadString(z^.zeit);
      WriteLn;WriteLn;
    END  erzeugedatensatz ;

  PROCEDURE Datensatzausgeben(z : zeiger);
    BEGIN
        IF z <> NIL THEN
        WriteLText(z^.name,20);
        WriteLText(z^.zeit,10);
        WriteLn;        END; (* of IF *)
    END Datensatzausgeben;

  PROCEDURE IstKleinerAls(x1 ,x2:ADDRESS):BOOLEAN;
      VAR a1,a2:zeiger;
      BEGIN
        a1:=x1; a2:=x2;
        IF CompareStr(a1^.name,a2^.name) = 1  THEN RETURN FALSE
                                              ELSE RETURN TRUE END;
      END IstKleinerAls;

 PROCEDURE IstGleich(x1 ,x2:ADDRESS):BOOLEAN;
      VAR a1,a2:zeiger;
      BEGIN
        a1:=x1; a2:=x2;
        IF CompareStr(a1^.name,a2^.name) <> 0 THEN RETURN FALSE
                                              ELSE RETURN TRUE END;
      END IstGleich;


  PROCEDURE ListeAusgebenVorwaerts;
    BEGIN
       ZumKopf(liste);
       Datensatzausgeben(AusgabeElement(liste));
       WHILE NOT letztesElement(liste) DO
        ZumnaechstenElement(liste);
        Datensatzausgeben(AusgabeElement(liste));
       END; (* of WHILE *)
  END  ListeAusgebenVorwaerts;


  PROCEDURE ListeAusgebenRueckwaerts;
    BEGIN
       ZumSchwanz(liste);
       Datensatzausgeben(AusgabeElement(liste));
       WHILE NOT erstesElement(liste) DO
         ZumvorigenElement(liste);
         Datensatzausgeben(AusgabeElement(liste));
       END; (* of WHILE *)
  END  ListeAusgebenRueckwaerts;


PROCEDURE ListeErzeugen;
   BEGIN
      ErzeugeListe(liste);
   END ListeErzeugen;

PROCEDURE AmKopfEinfuegen;
   VAR neu : zeiger;
   BEGIN
      erzeugedatensatz(neu);
      EinfuegenKopf(liste,neu);
   END AmKopfEinfuegen;

PROCEDURE AmSchwanzEinfuegen;
   VAR neu : zeiger;
   BEGIN
      erzeugedatensatz(neu);
      EinfuegenSchwanz(liste,neu);
   END AmSchwanzEinfuegen;

PROCEDURE AmKopfEntnehmen;
   BEGIN
     ZumKopf(liste);
     Datensatzausgeben(EntferneAusListe(liste));
   END AmKopfEntnehmen;

PROCEDURE AmSchwanzEntnehmen;
   BEGIN
     ZumSchwanz(liste);
     Datensatzausgeben(EntferneAusListe(liste));
   END AmSchwanzEntnehmen;

PROCEDURE InListeEinfuegen;
   VAR neu: zeiger;
   BEGIN
     erzeugedatensatz(neu);
     SortiertEinfuegen(liste,neu,IstKleinerAls);
   END InListeEinfuegen;

PROCEDURE InListeSuchen;
  VAR  auswahl: CHAR;
       schluessel: zeiger;
       vorhanden : BOOLEAN;
  BEGIN
     IF NOT leereListe(liste)
     THEN
     NEW(schluessel);
     WriteString('Name : ');
     ReadString(schluessel^.name); WriteLn;
     ZumVergleichselement(liste,schluessel,IstGleich,vorhanden);
     IF vorhanden
       THEN
         Datensatzausgeben(AusgabeElement(liste));
         WriteString('Datensatz loeschen (j/n) ? ');
         Read(auswahl);WriteLn;
         IF auswahl = 'j' THEN LoescheElement(liste) END;
       ELSE
         WriteString('Datensatz nicht vorhanden ! '); WriteLn; END;
       ELSE
         WriteString('Liste enthaelt keine Datenstze') END;
  END InListeSuchen;

PROCEDURE menue;
  TYPE menge = SET OF CHAR;
  CONST menge1 = menge{'1'..'9'}+menge{'e'};
  VAR auswahl : CHAR;
  BEGIN
   REPEAT
   REPEAT
    WriteLn;WriteLn;WriteLn;
    WriteString('Liste erzeugen          :      1');WriteLn;
    WriteString('Am Kopf einfuegen       :      2');WriteLn;
    WriteString('Am Schwanz einfuegen    :      3');WriteLn;
    WriteString('Am Kopf entnehmen       :      4');WriteLn;
    WriteString('Am Schwanz entnehmen    :      5');WriteLn;
    WriteString('In die  Liste einfuegen :      6');WriteLn;
    WriteString('In der  Liste suchen    :      7');WriteLn;
    WriteString('Liste ausgeben vorwrts :      8');WriteLn;
    WriteString('Liste ausgeben rckwrts:      9');WriteLn;
    WriteString('Programmende            :      e');WriteLn;
    WriteLn;
    WriteString('Bitte eingeben (1 - 9 oder e) : ');Read(auswahl);
    WriteLn;WriteLn;
   UNTIL auswahl IN menge1;
   CASE auswahl OF
     '1': ListeErzeugen|
     '2': AmKopfEinfuegen|
     '3': AmSchwanzEinfuegen|
     '4': AmKopfEntnehmen|
     '5': AmSchwanzEntnehmen|
     '6': InListeEinfuegen|
     '7': InListeSuchen|
     '8': ListeAusgebenVorwaerts|
     '9': ListeAusgebenRueckwaerts
     ELSE
     END; (* of CASE *)
   UNTIL auswahl = 'e';
  END menue;


BEGIN (*  Hauptprogramm  *)
  menue;
END tlist7.